# tkigc version 0.1h procs.tcl - June 4, 2007. 
# tkigc is a client for playing go on IGS (http://igs.joyjoy.net).
# written by Marc Greene <marc@mailshack.com> - http://tkigc.sourceforge.net

# Copyright (C) 2007 Marc Greene 

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# Also available on the internet at: http://www.gnu.org/licenses/gpl.txt

proc playVar {x y} {
   #called by mouse button 3 for playing out alternate variations
   global X coord bstonelist wstonelist turn playing scoring CX CY
   global variation dotick
   
   getCoords $x $y
   if {($X == 0)} { return }
   set variation 2
   set dotick 0
   if {($turn == "black")} {
         playBVar $x $y client 
   } else {
         playWVar $x $y client
   } 
}


proc putStone {sock x y} {
   #called by clicking mouse button 1 for playing actual moves during a game
   
   global X coord bstonelist wstonelist turn playing scoring CX CY
   global letter number
  
   getCoords $x $y
   if {($X == 0)} { return }
   if {($scoring == 1)} {
      numToCoords $coord
      realCoord $CX $CY
      puts $sock "$letter$number 3"
      return
   }

   foreach i "$bstonelist $wstonelist" {
      if {($coord == $i)} {
         puts stdout "\nLOCAL: No vacancy"
      }
   }
   if {($turn == "black")} {
      if {($playing == "black")} { 
         putBStone $sock $x $y 
      } else {
         return
      }
   } else {
      if {($playing == "white")} {
         putWStone $sock $x $y 
      } else {
         return
      }
   } 
}

proc bindStats { sock player } {
   #called when a player name is clicked on
   puts $sock "stats $player"
}

proc rmGroup { group } {
   #only used for removing groups during scoring
   global bstonelist wstonelist wcapt bcapt RX RY CX CY pointstatus
   global curgroup coord
   
   RCToCoords $group
   getCoords $RX $RY
   pointStatus "$coord"
   
   if {($pointstatus == 0)} { return }
   if {($pointstatus == 2)} { libertyCount "2" "$coord" }
   if {($pointstatus == 1)} { libertyCount "1" "$coord" }
   
   pointStatus "$coord"
   
   foreach stone $curgroup {
      numToCoords $stone

      if {($pointstatus == 2)} {
	 .c delete W-$CX$CY
	 .c delete thedot
         set wcapt [expr $wcapt+1]
         #.c itemconfigure Wcapt -text "$wcapt"
      } else {
         .c delete B-$CX$CY
	 .c delete thedot
         set bcapt [expr $bcapt+1]
         #.c itemconfigure Bcapt -text "$bcapt"
      }
   }
}


proc processBMove {x y} {  
   #called by putBStone and playBVar to
   #check for and remove any captured white stones 
   #caused by the black play:
   global X Y bstonelist wstonelist turn coord pointstatus libertycount
   global capmove capmoves movenum curgroup CX CY wcapt bcapt movelist
   global boldlist woldlist oldlist

   lappend bstonelist $coord
   for {set a 1} {$a < 5} {set a [expr $a+1]} {  
      if {($a == 1)} {set i [expr $coord-19]}
      if {($a == 2)} {set i [expr $coord+1]}
      if {($a == 3)} {set i [expr $coord+19]}
      if {($a == 4)} {set i [expr $coord-1]}
      pointStatus "$i"
      if {($pointstatus == 2)} {
         libertyCount "2" "$i"  
         if {($libertycount == 0)} { 
            set move [expr $movenum+1]
	    #these arrays used by stepBack function:
	    lappend capmoves $move
	    set capmove($move) "$curgroup" 
	    set oldlist($move) "$movelist"
	    set boldlist($move) "$bstonelist"
	    set woldlist($move) "$wstonelist"
	    foreach stone $curgroup {
               numToCoords $stone
               .c delete W-$CX$CY
               set wcapt [expr $wcapt+1]
               #.c itemconfigure Wcapt -text "$wcapt"
               #after removing dead stones, remove it from wstonelist:
	       set oldstonelist $wstonelist
               set wstonelist ""
               foreach z $oldstonelist {
                  if {($z != $stone)} { lappend wstonelist $z }
               }
            }
         }
      }
   }
}

proc processWMove {x y} { 
   global X Y bstonelist wstonelist turn coord pointstatus libertycount
   global capmove capmoves movenum curgroup CX CY wcapt bcapt movelist
   global boldlist woldlist oldlist
   lappend wstonelist $coord
   #check this stones adjacent intersections for enemies:
   for {set a 1} {$a < 5} {set a [expr $a+1]} {  
      if {($a == 1)} {set i [expr $coord-19]}
      if {($a == 2)} {set i [expr $coord+1]}
      if {($a == 3)} {set i [expr $coord+19]}
      if {($a == 4)} {set i [expr $coord-1]}
      pointStatus "$i"
      if {($pointstatus == 1)} {
         #an enemy was found, check the liberties for that group:
         libertyCount "1" "$i"  
         if {($libertycount == 0)} {
	    set move [expr $movenum+1]
            #indicate move as a capture move:
            lappend capmoves $move
            #save the captured stones in array associated with move number:
	    set capmove($move) "$curgroup"
            #save current movelists in array associated with move number:
	    set oldlist($move) "$movelist"
	    set boldlist($move) "$bstonelist"
	    set woldlist($move) "$wstonelist"
	    #visually remove captures from board and increment capture count:
            foreach stone $curgroup {
               numToCoords $stone
               .c delete B-$CX$CY
               set bcapt [expr $bcapt+1]
               #.c itemconfigure Bcapt -text "$bcapt"
               #remove captured stones from list of stones currently on board:
               set oldstonelist $bstonelist
               set bstonelist ""
               foreach z $oldstonelist {
                  if {($z != $stone)} { lappend bstonelist $z }
               }
            }
         }
      }
   }
}


proc putBStone {sock x y} {
   #left mouse click on board > putStone > if turn=black then putBStone:
   global CX CY X Y coord bstonelist wstonelist curgroup movelist 
   global libertycount pointstatus turn wcapt letter number playing scoring
   global capmove capmoves movenum wsimage bsimage
   
   #return if move is a pass:
   if {($x == "Pass")} {
      set turn "white"
      set movenum [expr $movenum+1]
      lappend bmovelist "BPass"
      lappend movelist "BPass"
      set letter "Pass"
      set number ""
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      return
   } else {
      set scoring 0
   }
   getCoords $x $y 
   
   #return if mouse is out of bounds:
   if {($X == 0)} { return }
   
   #return if coordinate is occupied:
   foreach i "$bstonelist $wstonelist" {
      if {($i == $coord)} {
	 return
       }
   }

   #capture any surrounding stones caused by this play:
   processBMove $x $y 

   #check to see if this play is legal (non suicide):
   libertyCount 1 $coord
   if {($libertycount == 0)} {
      #move is illegal suicide move, trim it out of list and do nothing:
      set bstonelist [lreplace $bstonelist end end]
   } else {
      #actually make the move, swap turns, update movelist etc:
      set turn "white"
      .c delete thedot
      .c create image $X $Y  -image $bsimage -tags "B-$X$Y stones"
      .c create oval [expr $X-3] [expr $Y-3] [expr $X+3] [expr $Y+3] \
                           -fill white -tags "thedot stones"
      realCoord $X $Y
      if {($playing == "black")} { 
         puts $sock "$letter$number 4"
      }
      set movenum [expr $movenum+1]
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      lappend movelist "$coord"
   }      
}

proc playBVar {x y movesource} {
   #called by setpForward, playVar, and also moveUpdate to handle moves from
   #the server (opponents moves):
   global CX CY X Y coord bstonelist wstonelist curgroup movelist 
   global libertycount pointstatus turn wcapt letter number playing scoring
   global variation capmove capmoves movenum wsimage bsimage
   if {($movesource == "server") && ($variation != 0)} { 
      return 
   }
   if {($x == "Pass")} {
      set turn "white"
      set movenum [expr $movenum+1]
      lappend bmovelist "BPass"
      lappend movelist "BPass"
      set letter "Pass"
      set number ""
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      return
   } else {
      set scoring 0
   }
   getCoords $x $y 
   
   #return if coordinate is occupied:
   foreach i "$bstonelist $wstonelist" {
      if {($i == $coord)} {
	 return
       }
   }
   
   #capture any white stones caused by this play:
   processBMove $x $y
  
   #check legality of move, source of move, and whether a variation 
   #is being currently being examined or not:
   libertyCount 1 $coord
   if {($libertycount == 0)} {   
      set bstonelist [lreplace $bstonelist end end]
   } elseif {(($movesource == "server") && ($variation == 0)) \
                                        || ($movesource == "client")} {
      #the move is either a variation from the client, or an actual move 
      #from the server that needs to be displayed now. If client is busy
      #looking at an alternate variation, then the server move was
      #stored in a list (in the updateMove proc).
      set turn "white"
      .c delete thedot
      .c create image $X $Y  -image $bsimage -tags "B-$X$Y stones"
      .c create oval [expr $X-3] [expr $Y-3] [expr $X+3] [expr $Y+3] \
                           -fill white -tags "thedot stones"
      realCoord $X $Y
      set movenum [expr $movenum+1]   
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      lappend movelist "$coord"
   }      
}


proc putWStone {sock x y} {
   #left mouse click on board > putStone > if turn=white then putWStone:
   global CX CY X Y coord bstonelist wstonelist libertycount pointstatus
   global wgroups curgroup turn bcapt letter number movelist playing scoring
   global capmove capmoves movenum wsimage boldlist woldlist oldlist
   
   #return if move is a pass:
   if {($x == "Pass")} {
      set turn "black"
      set movenum [expr $movenum+1]
      lappend wmovelist "WPass"
      lappend movelist "WPass"
      set letter "Pass"
      set number ""
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      return
   } else {
      set scoring 0
   }
   getCoords $x $y
   
   #return if mouse is out of bounds:
   if {($X == 0)} { return }

   #return if coordinate is occupied:
   foreach i "$wstonelist $bstonelist" {
      if {($i == $coord)} {
	 return
      }
   }
   
   #capture any black stones caused by this play:
   processWMove $x $y
   
   #check to see if move is legal (non suicide):
   libertyCount "2" "$coord"
   if {($libertycount == 0)} {
      set wstonelist [lreplace $wstonelist end end]
   } else {
      #actually make the move:
      set turn "black"
      .c delete thedot
      .c create image $X $Y  -image $wsimage -tags "W-$X$Y stones"
      .c create oval [expr $X-2] [expr $Y-2] [expr $X+2] [expr $Y+2] \
                                 -fill black -tags "thedot stones"
      realCoord $X $Y
      if {($playing == "white")} { puts $sock "$letter$number 1" }
      set movenum [expr $movenum+1]
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      lappend movelist "$coord"
   }
}

proc playWVar {x y movesource} {
   global CX CY X Y coord bstonelist wstonelist libertycount pointstatus
   global wgroups curgroup turn bcapt letter number movelist playing scoring
   global variation capmove capmoves movenum wsimage boldlist woldlist oldlist
   if {($movesource == "server") && ($variation != 0)} { 
      return 
   }
   if {($x == "Pass")} {
      set turn "black"
      set movenum [expr $movenum+1]
      lappend wmovelist "WPass"
      lappend movelist "WPass"
      set letter "Pass"
      set number ""
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      return
   } else {
      set scoring 0
   }
   getCoords $x $y
   foreach i "$wstonelist $bstonelist" {
      if {($i == $coord)} {
	 return
      }
   }
   processWMove $x $y
   libertyCount "2" "$coord"
   if {($libertycount == 0)} {
      set wstonelist [lreplace $wstonelist end end]
   } elseif {(($movesource == "server") && ($variation == 0)) \
                                        || ($movesource == "client")} {
      set turn "black"
      .c delete thedot
      .c create image $X $Y  -image $wsimage -tags "W-$X$Y stones"
      .c create oval [expr $X-2] [expr $Y-2] [expr $X+2] [expr $Y+2] \
                                 -fill black -tags "thedot stones"
      realCoord $X $Y
      set movenum [expr $movenum+1]
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      lappend movelist "$coord"
   }
}


proc getCoords { x y } {
   #Intersections start at 1 at the upper left, and progress downward.
   #At the bottom of the first collumnfor example is 19, the top
   #of the second collumn is 20, the last intersection is 361 (in the bottom
   #right corner). This converts the x y coordinates from mouse into a point 
   #in the numerical scheme. Sets vars X Y and coord.
   
   global X Y coord lineend linewidth
   
   #return if mouse is out of bounds:
   if {($x < 8) || ($x > [expr $lineend+10]) || ($y < 8) || \
       ($y > [expr $lineend+10])} {
      set X 0
      set coord 0
      return
   }
   
   #round mouse off to the nearest intersection, put new coords in X and Y:
   if {($x < 29)}  { set x 18 }
   if {($y < 29)}  { set y 18 }
   for {set a 28} {$a < $lineend} {set a [expr $a+$linewidth]} {
      if {($x > $a) && ($x < [expr $a+$linewidth+1])} {
         set x [expr $linewidth-10+$a]
      }
      if {($y > $a) && ($y < [expr $a+$linewidth+1])} {
         set y [expr $linewidth-10+$a]
      }
   }
   if {($x > [expr $lineend+11])} {set x $lineend}
   if {($y > [expr $lineend+11])} {set y $lineend}
   set X $x
   set Y $y
  
   #convert the corrected x y coordinates into a point, assign to coord:
   set crdcount 1
   for {set a 18 } {$a <= $lineend } {set a [expr $a+$linewidth]} {
      if {($x == $a)} {
         for {set i 18 } {$i <= $lineend } {set i [expr $i+$linewidth]} {
            if {($y == $i)} {set coord $crdcount} 
            set crdcount [expr $crdcount+1]
         }
      } else {
         set crdcount [expr $crdcount+19]    
      }
   }
}

proc libertyCount { color num } {
   global curgroup libertycount bstonelist wstonelist
   global pointstatus topedge bottomedge
   set curgroup $num
   set alreadythere 0
   set ncurgroup $curgroup
   set foundanother 1
   while {($foundanother == 1)} {
      set foundanother 0
      foreach stone $curgroup { 
         set checkstone [expr $stone+19]
         pointStatus $checkstone
         if {($pointstatus == $color)} {
            set alreadythere 0
            foreach nstone $ncurgroup {
               if {($checkstone == $nstone)} {
                  set alreadythere 1
                  break
               }
            }          
            if {($alreadythere == 0)} {
               lappend ncurgroup $checkstone
               set foundanother 1
            }
         }
      }
      set curgroup $ncurgroup
      foreach stone $curgroup {
         set checkstone [expr $stone-19]
         pointStatus $checkstone
         if {($pointstatus == $color)} {
            set alreadythere 0
            foreach nstone $ncurgroup {
            if {($checkstone == $nstone)} {
               set alreadythere 1
                  break
               }
            }
            if {($alreadythere == 0)} {
               lappend ncurgroup $checkstone
               set foundanother 1
            }
         }
      }
      set curgroup $ncurgroup
      foreach stone $curgroup {
         set checkstone [expr $stone-1]
         pointStatus $checkstone
         if {($pointstatus == $color)} {
            set alreadythere 0
            foreach nstone $ncurgroup {
               if {($checkstone == $nstone)} {
                  set alreadythere 1
                  break
               }
               foreach tedgestone $topedge {
                  if {($nstone == $tedgestone)} {
                     foreach bedgestone $bottomedge {
                        if {($checkstone == $bedgestone)} {
                           set alreadythere 1
                           break
                        }
                     }
                  }
               }
            }
            if {($alreadythere == 0)} {
               lappend ncurgroup $checkstone
               set foundanother 1
            }
         }
      }
      set curgroup $ncurgroup
      foreach stone $curgroup {
         set checkstone [expr $stone+1]
         pointStatus $checkstone
         if {($pointstatus == $color)} {
            set alreadythere 0
            foreach nstone $ncurgroup {
               if {($checkstone == $nstone)} {
                  set alreadythere 1
                  break
               }
               foreach bedgestone $bottomedge {
                  if {($nstone == $bedgestone)} {
                     foreach tedgestone $topedge {
                        if {($checkstone == $tedgestone)} {
                           set alreadythere 1
                           break
                        }
                     }
                  }
               }
            }
            if {($alreadythere == 0)} {
               lappend ncurgroup $checkstone 
               set foundanother 1
            }
         }
      }   
      set curgroup $ncurgroup
   }
   set libertycount 0
   foreach stone $curgroup {
      set checkstone [expr $stone+1]
      pointStatus $checkstone
      set isontop 0
      foreach tedgestone $topedge {
         if {($stone == $tedgestone)} {
            set isontop 1
         }
      }
      set isonbottom 0
      foreach bedgestone $bottomedge {
         if {($stone == $bedgestone)} {
             set isonbottom 1
         }
      }
      if {($isonbottom != 1) && ($pointstatus == 0)} {
         set libertycount 1
         return 
      }
      set checkstone [expr $stone-1]
      pointStatus $checkstone
      if {($isontop != 1) && ($pointstatus == 0)} {
         set libertycount 1
         return
      }
      pointStatus [expr $stone-19]
      if {($pointstatus == 0) && ($stone > 19) } {
         set libertycount 1
         return
      }
      pointStatus [expr $stone+19]
      if {($pointstatus == 0) && ($stone < 343) } {
         set libertycount 1
         return
      }
   }     
} 

proc numToCoords { coord } {
   #opposite of getCoords, converts a point in the numerical scheme
   #to the X Y pixel coordinates. Stores coordinates in CX and CY:
   global CX CY lineend linewidth
   set crdcount 1
   for {set a 18 } {$a <= $lineend } {set a [expr $a+$linewidth]} {
      if {($coord >= $crdcount) && ($coord < [expr $crdcount+19])} { set CX $a }
      set crdcount [expr $crdcount+19]
   }
   set t 1
   set crdcount 1
   for {set a 18} {$a <= $lineend} {set a [expr $a+$linewidth]} {
      for {set i 1} {$i <=19} {set i [expr $i+1]} {
         if {($coord == $crdcount)} { set CY $a }
            set crdcount [expr $crdcount+19]
      }
      set t [expr $t+1]
      set crdcount $t
   }
}        
   
proc pointStatus { num } {
   #determines if any point in grid is black (1), white (2), or empty (0):
   global bstonelist wstonelist pointstatus
   set pointstatus 0
   foreach i $wstonelist {
      if {($num == $i)} { set pointstatus 2 }
   }
   foreach i $bstonelist {
      if {($num == $i)} { set pointstatus 1 }      
   }
}

proc rmStone {x y} {
   #this function only used for removing groups during scoring.
   global X Y coord wstonelist bstonelist
   getCoords $x $y  
   .c delete B-$X$Y
   .c delete W-$X$Y
   
   set oldstonelist $wstonelist
   set wstonelist ""
   foreach i $oldstonelist {
      if {($i != $coord)} { lappend wstonelist $i }
   }
   
   set oldstonelist $bstonelist
   set bstonelist ""
   foreach i $oldstonelist {
      if {($i != $coord)} { lappend bstonelist $i }
   }
}

proc refreshBoard {sock} {
   global gamenum
   resetBoard
   puts $sock "moves $gamenum"
}

proc resetBoard {} {
   global turn movelist bstonelist wstonelist wcapt bcapt variation sfwdlist
   global capmove capmoves boldlist woldlist oldlist movenum smovenum sfwdlist2
   set boldlist() ""
   set woldlist() ""
   set oldlist() ""
   set scoring 0
   set wcapt 0
   set bcapt 0
   set playcount 0
   set variation 0
   set dotick 0
   .c delete stones
   .c delete Bpoints 
   .c delete Wpoints
   set bstonelist ""
   set wstonelist ""
   set capmoves ""
   set movenum 0
   set smovenum ""
   for {set maxmoves 0} {$maxmoves < 450} {set maxmoves [expr $maxmoves+1]} {
      set capmove($maxmoves) ""
   }
   set movelist "none"
   set sfwdlist ""
   set sfwdlist2 ""
   .c itemconfigure Coords -text "Move $movenum:   " 
   #.c create text 30 475 -text "captured:"
   #.c itemconfigure Wcapt -text "$wcapt"
   #.c itemconfigure Bcapt -text "$bcapt"
   set turn "black"
   #.c itemconfigure Turn -fill $turn -text "$turn to move..."
}

proc RCToCoords { rcoord } {
   #converts letter/number coordintates (eg. "Q16") into
   #real pixel coordinate for intersection:
   global RX RY lineend linewidth
   regexp {(.)([0-9]*)} $rcoord z a n
   set letters {A B C D E F G H J K L M N O P Q R S T}
   set alpha 18
   set num $lineend
   for {set i 0} {$i < 19} {set i [expr $i+1]} {
      if {($a == [lindex $letters $i])} { set RX $alpha }
      if {($n == [expr $i+1])} { set RY $num }
      set alpha [expr $alpha+$linewidth]
      set num [expr $num-$linewidth]
   }
}

proc realCoord { x y } { 
   #converts x y pixel coordinates into letter/number coordinates:
   
   global letter number lineend linewidth
   set letters {A B C D E F G H J K L M N O P Q R S T}
   set a 18
   set b $lineend
   for {set i 0} {$i < 19} {set i [expr $i+1]} {
     if {($x == $a)} { set letter [lindex $letters $i] }
     if {($y == $b)} { set number [expr $i+1] }
     set a [expr $a+$linewidth]
     set b [expr $b-$linewidth]
   }
}
proc drawCoords {} {
   #function to handle on/off display of coordinates around edge of board:
   
   global drawcoords lineend linewidth
   if {($drawcoords == 0)} {
      .c delete Dcoords
      set drawcoords 1
      return
   }
   set drawcoords 0
   set letters {A B C D E F G H J K L M N O P Q R S T}
   set x 18
   for {set i 0} {$i < 19} {set i [expr $i+1]} {
      .c create text $x 8 -text [lindex $letters $i] -tags Dcoords
      set x [expr $x+$linewidth]
   }
   
   set y $lineend
   for {set i 1} {$i < 20} {set i [expr $i+1]} {
      .c create text 8 $y -text $i -tags Dcoords
      set y [expr $y-$linewidth]
   }
}

proc stepForward {sock} {
   global sfwdlist letter number bstonelist wstonelist 
   global turn CX CY movenum smovenum variation sfwdlist2   
   if {($variation == 0)} { return }
   if {($variation == 1)} {
      if {($movenum == $smovenum)} {
	 refreshBoard $sock
	 return
      }
      if {($sfwdlist == "")} {
         if {($sfwdlist2 != "")} {
            set sfwdlist $sfwdlist2
            set sfwdlist2 ""
	 }  
      }
   } 
   if {($sfwdlist == "")} { return }
   #puts stdout "stepForward: movenumn: $movenum smovenum: \
   #             $smovenum sfwdlist: -$sfwdlist-"   
   set nextmove [lindex $sfwdlist end]
   if {($nextmove == "BPass") || ($nextmove == "WPass")} {
      if {($turn == "black")} {
         playBVar Pass Pass client
      } else {
         playWVar Pass Pass client
      } 
   } 
   set sfwdlist [lreplace $sfwdlist end end] 
   
   numToCoords $nextmove
   if {($turn == "black")} {
      playBVar $CX $CY client
   } else {
      playWVar $CX $CY client
   } 
}

proc changeBack {c} {
   global background backgrounds SIZE
   if {($backgrounds == "")} {
      set backgrounds [glob backgrounds/*$SIZE.gif]
   }
   set background [lindex $backgrounds 0]
   set backgrounds [lreplace $backgrounds 0 0]
   drawBoard $c
   $c raise stones
   $c raise Coords
   $c raise Dcoords
   $c raise Login
   $c raise Whiteplayer
   $c raise Blackplayer
   $c raise Wclock 
   $c raise Bclock 
   #$c raise Vs
}

proc stepBack {} {
   global CX CY turn movelist bstonelist wstonelist letter number 
   global sfwdlist variation movenum capmove capmoves bsimage wsimage
   global oldlist boldlist woldlist bcapt wcapt dotick
   
   if {($movelist == "none")} { return }
   if {($variation == 0)} { 
      set variation 1 
      set dotick 0
   }
   set lastmove [lindex $movelist end]   
   
   #chop last move from movelists
   if {($lastmove == [lindex $bstonelist end])} {
      set bstonelist [lreplace $bstonelist end end]
   }
   if {($lastmove == [lindex $wstonelist end])} {
      set wstonelist [lreplace $wstonelist end end]
   } 
   set movelist [lreplace $movelist end end]
   
   if {($lastmove == "BPass") || ($lastmove == "WPass")} {
      .c delete thedot
      if {($turn == "black")} {
         set turn "white"
      } else { 
         set turn "black"
      }
      if {($movenum > 0)} { set movenum [expr $movenum-1] }
      .c itemconfigure Coords -text "Move $movenum: Pass"
   }
   
   lappend sfwdlist $lastmove
   numToCoords $lastmove
   realCoord $CX $CY
   set move [expr $movenum-1]
   if {($move < 1)} {
      set capmoves ""
      set movenum 0
      set move 0
      set turn "black"
      set letter ""
      set movelist "none"
      set bstonelist ""
      set wstonelist ""
      set number ""
      .c itemconfigure Coords -text "Move $movenum: $letter$number"
      #.c itemconfigure Turn -fill $turn -text "$turn to move..."
      .c delete thedot
      .c delete W-$CX$CY
      .c delete B-$CX$CY
      return
   }
   foreach cmove $capmoves {
      if {($movenum == $cmove) && ($capmove($movenum) != "")} {
	 set movelist $oldlist($movenum)
	 set bstonelist $boldlist($movenum)
	 set wstonelist $woldlist($movenum)
         foreach capstone "$capmove($movenum)" {
	    numToCoords $capstone
	    if {($turn == "black")} {
	       set bcapt [expr $bcapt-1]
	       #.c itemconfigure Bcapt -text "$bcapt"
	       .c create image $CX $CY  -image $bsimage -tags "B-$CX$CY stones" 
	    } else {
	       set wcapt [expr $wcapt-1]
	       #.c itemconfigure Wcapt -text "$wcapt"
	       .c create image $CX $CY  -image $wsimage -tags "W-$CX$CY stones"
            }
         }
	 set capmove($movenum) ""
	 if {($turn == "white")} {
	    set bstonelist [lreplace $bstonelist end end]
	 } else {
	    set wstonelist [lreplace $wstonelist end end]
	 }
      }
   }
   numToCoords $lastmove	     
   .c delete thedot
   .c delete W-$CX$CY
   .c delete B-$CX$CY
   if {($turn == "black")} {
      set turn "white"
   } else { 
      set turn "black"
   }
   if {($movenum > 0)} { set movenum [expr $movenum-1] }
   #.c itemconfigure Turn -fill $turn -text "$turn to move..."
   numToCoords [lindex $movelist end]
   realCoord $CX $CY
   .c itemconfigure Coords -text "Move $movenum: $letter$number"
   
   # need a LOCAL 'refresh' button to come back to current
   # after stepping forward and back.   
}

proc getMatchInfo { sock data } {
   global getlogin opponent whiteplayer blackplayer gamenum
   regexp {(9 Match \[)([0-9]*)(.*with.)(.*)(.in.*)} $data zz z gamenum y opponent x
   regexp {(9 Creating match \[)([0-9]*)(.*with.)(.*)(\.)} $data zz z gamenum y opponent x
   regexp {(9 )(.*)( has rest.*your.*game.*)} $data zz z opponent y
   if {($opponent == $getlogin)} {
      if {($opponent == $blackplayer)} {
         set opponent $whiteplayer
      } else {
         set opponent $blackplayer
      }
   }
   resetBoard
}

proc setGameInfo { sock data } {
   global playing display gamenum bcaps bbyostones  turn
   global wcaps wbyostones whiteplayer blackplayer opponent variation
   global whiterank blackrank getrankinfo dotick wtime btime

   set btime ""
   set bbyostones "--"
   set wtime ""
   set wbyostones "--"
   
   regexp {(15.Game )([0-9]*)( I: )(.*)( \()([0-9]*)( )([0-9]*)( )(-?[0-9]*)(\) vs )(.*)( \()([0-9]*)( )([0-9]*)( )(-?[0-9]*)(.*)} $data zz z gamenum y whiteplayer x wcaps w wtime v wbyostones u blackplayer t bcaps s btime r bbyostones q
   
   if {($wbyostones == "-1")} {set wbyostones "--"}
   if {($bbyostones == "-1")} {set bbyostones "--"}
   
   if {($btime < 30) && ($bbyostones != "--")} {
      .c itemconfigure Bclock -fill red
   } else {
      .c itemconfigure Bclock -fill black
   }
   if {($wtime < 30) && ($wbyostones != "--")} {
      .c itemconfigure Wclock -fill red
   } else {
      .c itemconfigure Wclock -fill white
   }
   set dotick 0   
   .c itemconfigure Wclock -text "[convertTime $wtime] / $wbyostones"
   .c itemconfigure Bclock -text "[convertTime $btime] / $bbyostones"
   if {($variation == 0)} { after 1000 set dotick 1 }
   #.c itemconfigure Vs -text "vs"
   .c itemconfigure Blackplayer -text "$blackplayer $blackrank"
   .c itemconfigure Whiteplayer -text "$whiteplayer $whiterank" 
   
   if {($playing == "yes")} {
      if {($opponent == $whiteplayer)} { set playing "black" } 
      if {($opponent == $blackplayer)} { set playing "white" }
      puts $sock "moves $gamenum"
      puts $sock "games $gamenum"
      set getrankinfo 1
   }
   if {($playing == "observe")} {
      set opponent ""
      puts $sock "moves $gamenum"
      set playing "observing"
   }
}

proc moveUpdate { sock data } {
   #called from fromServer when a move is recieved from the server
   global RX RY playing smovenum movenum sfwdlist sfwdlist2 coord variation
   set smovenum ""
   regexp {([0-9]*)(\([BW]\): )(.[0-9]*)} \
                                       $data zz smovenum color rcoord
   regexp {([0-9]*)(\([BW]\): )(Pass)} \
                                       $data zz smovenum color rcoord
   #puts stdout "movenum: -$movenum-     smovenum: -$smovenum-"
   
   #check to see if a variation is being explored, if so, catch server
   #moves in a temporary list instead of displaying them:
   if {($smovenum != $movenum) && ($variation == 1)} { 
      RCToCoords $rcoord
      getCoords $RX $RY
      if {($sfwdlist != "")} {
	 set sfwdlist2 [linsert $sfwdlist2 0 $coord] 
         #puts stdout "sfwdlist2 added: $coord: -$sfwdlist2-"
         return
      } 
   }

   if {($smovenum != "")} {
      if {($smovenum == 0)} { 
         set movenum 0
         resetBoard
      }    
      if {[string match "*B*" $color]} {
         if {($rcoord == "Pass")} {
            playBVar Pass Pass server
	    puts stdout "\nBlack ($movenum): Pass"
         } else {
         RCToCoords $rcoord
         playBVar $RX $RY server
         }
      } else {
         if {($rcoord == "Pass")} {
            playWVar Pass Pass server
	    puts stdout "\nWhite ($movenum): Pass"
         } else {
            RCToCoords $rcoord
            playWVar $RX $RY server
         }
      }
   }
}

proc filterOutput {data} {
   #trims visual garbage out of server output, create login, password
   #and general prompt:
   global gamenum getlogin connected whiteplayer blackplayer loggedin
   global lastline serverinfo CONSOLE SERVER
   
   set prompt ""
   if [ regsub "\nIGS entry" $data "\nIGS entry"   data ] {
      .c itemconfigure Login -text "$SERVER"
      set loggedin 1
   }
   if [ regsub "\n1 5" $data "\n"      data ] {
      set prompt "tkigc> "
      .c itemconfigure Login -text "$SERVER"
      set loggedin 1
   }
   if [ regsub "\n...1 5" $data "\n"      data ] {
      set prompt "tkigc> "
      .c itemconfigure Login -text "$SERVER"
      set loggedin 1
   }
   if {($connected == "no") && ([ regexp {(@@@@@@@@@@@@)} $data ])} {
      set connected "yes"
      .c itemconfigure Login -text "Login..."
      .c delete Srvrprt
   }
   if [ regexp {(^....1 1.$)} $data ] {
      puts -nonewline stdout "Password: "
      .c itemconfigure Login -text "Password..."
      if {($CONSOLE == yes)} {
         $serverinfo configure -state normal
         $serverinfo insert end "\n\nPassword: "
         $serverinfo see end	       
         $serverinfo configure -state disabled
      }
   } elseif [ regexp {(11 Kibitz) (.*:) (.*\]$)} $data \
                                     zz z kbplayer gminfo ] {
      regexp {(11 .*) (.*$)} $data zz z kbdata
      puts stdout "$kbplayer $kbdata"
      if {($CONSOLE == yes)} {
         $serverinfo configure -state normal
         $serverinfo insert end "$kbplayer $kbdata"
         $serverinfo see end
         $serverinfo configure -state disabled
      }
   } else {
            
      if [ regexp {\{Game\ [0-9]*:\ .*\ vs\ .*\ :\ W\ .*\ B\ .*\}} $data zz ] {
         puts "$zz"
      }
      if [ regexp {(^2\ .*)(24\ )(.*)} $data zz z y tell] {
         regsub "\n1 \[0-9\]" $tell "" tell
	 regsub "\n9 "  $tell "" tell
	 puts -nonewline "\n\n$tell$prompt"
	 regsub {(^2\ .*)(24\ )(.*)} $data "" data
      }
      if {($loggedin == 1)} {
         if {([ string length $data ]) < 20} { 
	    return 
	 } 
      } 
      regsub -all "\n1 \[0-9\]"              $data    "\n"   data
      regsub -all  "^1 \[0-9\]"              $data    ""     data
      regsub -all "\n\[1-9\]\[0-9\]? File"   $data    "\n"   data
      if [regsub -all "\n\[12\]\[52\] .*"    $data    ""     data] {return}
      regsub -all "\n\[0-9\]\[0-9\]? "       $data    "\n"   data 
      regsub -all  "^\[0-9\]\[0-9\]? "       $data    ""     data    
      regsub -all  {7 \[##\]}                $data    {[##]} data
      regsub "^Game .*"                      $data    ""     data
      if {([ string length $data ]) > 3} { 
         puts -nonewline stdout "$data" 
	 if {($CONSOLE == yes)} {
	    $serverinfo configure -state normal
            $serverinfo insert end "$data"
	    $serverinfo see end
	    $serverinfo configure -state disabled
	 }
      }
      if { $prompt != "" } {
         puts -nonewline stdout $prompt
      }
   }
}	    

proc convertTime {time} {
   #convert seconds into hours:minutes:seconds
   if {($time == "")} {set time 0}
   set hours [expr $time/3600]
   set minutes [expr ($time/60)%60] 
   set seconds [expr $time%60]
   if ![ regexp {..} $seconds ] { set seconds "0$seconds" }
   if {($hours > 0)} {
      if ![ regexp {..} $minutes ] { set minutes "0$minutes" }
      return "$hours:$minutes:$seconds"
   } else {
      return "$minutes:$seconds"
   }
}

proc fromServer {sock} {
     #processes information coming from server
     global playing opponent gamenum whiteplayer blackplayer getrankinfo
     global whiterank blackrank lastline variation scoring wcapt
     global bcapt time bbyostones wbyostones komi handi playcount dotick
     set obcount 0
     set playcount 0
     set data x
     while {[string length $data]} {
         set data [read $sock]
         if {[eof $sock]} {
	     puts "Disconnected.\n" 
	     .c itemconfigure Login -text "Disconnected."
	     disconnect $sock
	     return
         }
         if {[string length $data]} {
	    
	    #puts -nonewline "$data"
	    filterOutput $data
	    
	    set data2 "$lastline$data"
            set linelist [split $data2 "\n$"]
            foreach dataline $linelist {
	       set lastline $dataline
                  if {[string match "9 Match*accepted*" $dataline] \
                  || [string match "9 Creating match*" $dataline] 
                  || [string match "9 * has rest*d*your*game*" $dataline]} {
                     set scoring 0
                     if {($playing == "observing")} { 
		        puts $sock "unob" 
		        set obcount 0
		     }
		  resetBoard
		  set playing "yes"
		  set playcount 1
                  getMatchInfo $sock $dataline
		  setGameInfo $sock $dataline
		  .c bind Blackplayer <1> "bindStats $sock $blackplayer"
		  .c bind Whiteplayer <1> "bindStats $sock $whiteplayer"
		  					 }        
	       if {[string match "*9 Adding*obser*" $dataline]} {
	          resetBoard
		  set scoring 0
	          set playing "observe" 
		  set obcount 1
	       }
	       if [ regexp {15 Game [0-9]* I: .* \(-?[0-9]* -?[0-9]* -?[0-9]*\) vs .* \(-?[0-9]* -?[0-9]* -?[0-9]*\)} $dataline ] { 

	          setGameInfo $sock $dataline
		  if {($obcount == 1) || ($playcount == 1)} {
                     puts $sock "games $gamenum"
		     set getrankinfo 1
		     .c bind Whiteplayer <1> "bindStats $sock $whiteplayer"
		     .c bind Blackplayer <1> "bindStats $sock $blackplayer"
		   }
	       } elseif [ regexp {[0-9]*\([WB]\): [A-T][0-9]*.*$}  \
	                                               $dataline ] {
		  moveUpdate $sock $dataline 
	       } elseif [ regexp {(Removed game file .* from database.)} \
	                                                     $dataline ] {
	          set playing ""
	          set dotick 0
		  set gamenum ""
		  #.c itemconfigure Gamenum -text ""
	          .c itemconfigure Whiteplayer -text ""
	          .c itemconfigure Blackplayer -text ""
	          .c itemconfigure Playing -text ""
	       }
	       
	       #get rank from 'games $gamenum' output:
	       if {($getrankinfo == 1) && \
      [string match "*$gamenum*$whiteplayer*vs.*$blackplayer*" "$dataline"]} {
		  regsub -all {[\[\]]} $dataline "" dataline
		  set whiterank [lindex $dataline 3]
		  set blackrank [lindex $dataline 6]
                  .c itemconfigure Blackplayer -text "$blackplayer $blackrank"
                  .c itemconfigure Whiteplayer -text "$whiteplayer $whiterank" 
		  if {($playing == "observing")} {
		     puts -nonewline "Observing"
		  } else {
		     puts -nonewline "Playing"
		  }
		  puts -nonewline " game $gamenum: $whiteplayer"
		  puts " $whiterank   vs.   $blackplayer $blackrank\n"
		  set getrankinfo 0
	       }
	       if {($playing == "observing")} {
	          if {([ regexp {has adjourned.}  $dataline]) || \
                      ([ regexp {forfeits on time.} $dataline]) || \
   ([ regexp {Game [0-9]*: .* vs .*} $dataline]) || \
   ([ regexp {Removing game [1-9]* from observation list.} $dataline ])} {
	             #puts "\nLOCAL: Not observing"
		     set playing ""
		     set gamenum ""
		     set movenum 0
		     set obcount 0
		     set scoring 0
		     set dotick 0
		     .c itemconfigure Playing -text ""
		  }
	       }
               if [regexp {(^9\ Removing\ @\ )(.*)} \
	                                              $dataline zz z group] {
		  rmGroup "$group"
               }
               if [regexp {^9 You can check your score .*} $dataline] {
                  puts "\nLOCAL: Remove dead stones."
                  set scoring 1
               }
	       if [regexp {^22.*} $dataline] { 
                  if {([lindex $dataline 1] == "$whiteplayer")} {
                     resetBoard
		     set whiterank  [lindex $dataline 2]
                     set wcapt      [lindex $dataline 3]
                     set wtime      [lindex $dataline 4]
                     set wbyostones [lindex $dataline 5]
                     set komi       [lindex $dataline 7]
                     set handi      [lindex $dataline 8]
                  } elseif {([lindex $dataline 1] == "$blackplayer")} {
                     set blackrank  [lindex $dataline 2]
                     set bcapt      [lindex $dataline 3]
                     set btime      [lindex $dataline 4]
                     set bbyostones [lindex $dataline 5]
                     set komi       [lindex $dataline 7]
                     set handi      [lindex $dataline 8]
                     set dotick 0 
                     .c itemconfigure Wclock -text \
		                           "[convertTime $wtime] / $wbyostones"
                     .c itemconfigure Bclock -text \
		                           "[convertTime $btime] / $bbyostones"
                     #.c itemconfigure Vs -text "  vs"
                     if {($variation == 0)} { after 1000 set dotick 1 }
                     .c itemconfigure Blackplayer -text \
		                           "$blackplayer $blackrank"
                     .c itemconfigure Whiteplayer -text \
		                           "$whiteplayer $whiterank" 
                  }
		  if [regexp {(^22\ \ ?)([0-9][0-9]?)(: )([0-5]*)} $dataline zz z row y rowinfo] {
		     set pos [expr ($row*19)+1]
                     set rowinfo [split $rowinfo ""]
                     processScoreRow $rowinfo $pos
                  }
	       }
            }
         }  
     }
}
      
proc processScoreRow { rowinfo pos } { 
   global CX CY wsimage bsimage
   
   for {set col 0} {$col<19} {set col [expr $col+1]} {
      numToCoords $pos
      switch [lindex $rowinfo $col] {
         "0" { .c create image $CX $CY -image $bsimage -tags "stones"}
	 "1" { .c create image $CX $CY -image $wsimage -tags "stones" }
	 "4" { .c create text $CX $CY -text "W" -fill white -tags Wpoints }
	 "5" { .c create text $CX $CY -tex "B" -tags Bpoints }
      }
      set pos [expr $pos+1]
   }
}

proc disconnect {sock} {
   global closed
   close $sock
   set closed($sock) 1
}

proc logOut {} {
   global connected sock
   if {($connected == "yes")} {
      puts $sock "quit"
   } else {
      puts stdout "Quitting."
      disconnect $sock 
   }
}

proc toServer {sock} {
     global global whiteplayer blackplayer gamenum getlogin variation
     global playing dotick
     if {[gets stdin line] >= 0} {
	     if {($getlogin == 0)} { 
	        set getlogin $line
		.c bind Login <1> "bindStats $sock $getlogin"
		.c bind Blackplayer <1> "bindStats $sock $getlogin"
		.c bind Whiteplayer <1> "bindStats $sock $getlogin"
	     }
       if [ regsub -all "^refresh" $line "\nmoves $gamenum" line ] {
          resetBoard
       }
       if [ regexp {^unob.*} $line ] { 
          set playing "" 
	  .c itemconfigure Playing -text ""
	  set dotick 0
       }
       #Disallow observing more than one game:
       if {($playing == "observing")} {
          if [ regsub -all "^ob .*" $line "" line ] {
	    puts stdout "\nLOCAL: Cannot observe more than one game at a time\n"
	  }
       }
       regexp {(^load )(.*)(-)(.*)} $line zz z whiteplayer y blackplayer
         #puts stdout "$gamenum"
	 puts $sock $line
     } else {
         return
     }
}

proc sendCommand {} {
   global inputval sock
   puts $sock "$inputval"
   set inputval ""
}

proc tickClock {} {
   global dotick wtime btime turn bbyostones wbyostones
   if {($turn == "black") && ($dotick == 1)} {
      incr btime -1
      if {($btime >= 0)} {
         .c itemconfigure Bclock -text "[convertTime $btime] / $bbyostones"
      } else {
	 set t [expr abs($btime)]
         .c itemconfigure Bclock -text "-[convertTime $t] / $bbyostones"
      }
   } elseif {($turn == "white") && ($dotick == 1)} {
      incr wtime -1
      if {($wtime >= 0)} {
         .c itemconfigure Wclock -text "[convertTime $wtime] / $wbyostones"
      } else {
         set t [expr abs($wtime)]
         .c itemconfigure Wclock -text "-[convertTime $t] / $wbyostones"
      }
   }
   if {($btime < 30) && ($bbyostones != "--")} {
      .c itemconfigure Bclock -fill red
   } else {
      .c itemconfigure Bclock -fill black
   }
   if {($wtime < 30) && ($wbyostones != "--")} {
      .c itemconfigure Wclock -fill red
   } else {
      .c itemconfigure Wclock -fill white
   }
   after 1000 tickClock
}

proc drawBoard {c} {
   global SERVER PORT CONSOLE sock bsimage wsimage background commands
   global linewidth width height bstone wstone lineend connected serverinfo
   #images for stones, board, and control buttons
   set bsimage [image create photo -file $bstone]
   set wsimage [image create photo -file $wstone]
   set backg [image create photo -file $background \
              -width $width -height $height]
   set stepf [image create photo -file icons/gtk-media-play-ltr.gif]
   set stepb [image create photo -file icons/gtk-media-play-rtl.gif]
   set rfrsh [image create photo -file icons/gtk-media-stop.gif]
   #set stepff [image create photo -file icons/gtk-media-previous-rtl.gif]
   #set stepbb [image create photo -file icons/gtk-media-previous-ltr.gif]
   set logout [image create photo -file icons/gtk-close.gif]
   set prefs [image create photo -file icons/gtk-preferences.gif]

   #put image on canvas:
   $c delete BG
   $c create image [expr $width/2] [expr $height/2] -image $backg  -tags BG

   #basic grid:
   set linestart 18
   for {set i 1} {$i < 20} {set i [expr $i+1]} {
      .c create line 18 $linestart $lineend $linestart -fill black
      set linestart [expr $linestart+$linewidth]
   }
   set linestart 18
   for {set i 1} {$i < 20} {set i [expr $i+1]} {
      .c create line $linestart 18 $linestart $lineend -fill black
      set linestart [expr $linestart+$linewidth]
   }

   #star points:
   set p1 [expr $linewidth*3+16]
   set p2 [expr $linewidth*9+16]
   set p3 [expr $linewidth*15+16]
   set c1 [expr $linewidth*3+20]
   set c2 [expr $linewidth*9+20]
   set c3 [expr $linewidth*15+20]

   .c create oval  $p1 $p1 $c1 $c1 -fill black
   .c create oval  $p2 $p1 $c2 $c1 -fill black
   .c create oval  $p3 $p1 $c3 $c1 -fill black
   .c create oval  $p1 $p2 $c1 $c2 -fill black
   .c create oval  $p2 $p2 $c2 $c2 -fill black
   .c create oval  $p3 $p2 $c3 $c2 -fill black
   .c create oval  $p1 $p3 $c1 $c3 -fill black
   .c create oval  $p3 $p3 $c3 $c3 -fill black
   .c create oval  $p2 $p3 $c2 $c3 -fill black
   
   #info and controls along bottom of canvas:
   set line1 [expr $height-51]
   set line2 [expr $height-35]
   set line3 [expr $height-15]
   set xcenter [expr $width/2]
   if {($connected == "no")} { 
      .c create text 50  $line1 -text "Connecting to:" -fill black -tags Login
      .c create text 145 $line1 -text "$SERVER:$PORT" -fill black -tags Srvrprt
   } 
      
   .c create text [expr $xcenter-55] $line1 \
                  -text "" -fill white -tags Whiteplayer
   #.c create text [expr $xcenter-5]  $line1 \
   #               -text "" -fill grey25 -tags Vs
   .c create text [expr $xcenter+55] $line1 \
                  -text "" -fill black -tags Blackplayer
   .c create text [expr $width-50] $line1 -text "" -fill black -tags Coords
   .c create text [expr $xcenter-55] $line2 -text "" -fill white -tags Wclock
   .c create text [expr $xcenter+55] $line2 -text "" -fill black -tags Bclock
   .c create image 20                 $line3 -image $prefs -tags Prefs
   #.c create image [expr $xcenter-70] $line3 -image $stepbb -tags Stepback
   .c create image [expr $xcenter-35] $line3 -image $stepb -tags Stepback
   .c create image $xcenter           $line3 -image $rfrsh -tags Reset
   .c create image [expr $xcenter+35] $line3 -image $stepf -tags Stepforward
   #.c create image [expr $xcenter+70] $line3 -image $stepff -tags Stepforward
   .c create image [expr $width-15]   $line3 -image $logout -tags Logout
   .c config -cursor hand1

   #mouse bindings:
   if {($CONSOLE == yes)} {
      bind $commands   <KeyRelease-Return>  "sendCommand"
      bind $serverinfo <KeyRelease-Return>  "sendCommand"
      bind .console    <1>                  "focus $commands"
   }

   bind $c          <1>                  "putStone $sock %x %y"
   bind $c          <3>                  "playVar %x %y"
   .c bind Prefs <Enter> ".c config -cursor hand2"
   .c bind Prefs <Leave> ".c config -cursor hand1"
   .c bind Reset <Enter> ".c config -cursor hand2"
   .c bind Reset <Leave> ".c config -cursor hand1"
   .c bind Logout <Enter> ".c config -cursor hand2"
   .c bind Logout <Leave> ".c config -cursor hand1"
   .c bind Stepforward <Enter> ".c config -cursor hand2"
   .c bind Stepforward <Leave> ".c config -cursor hand1"
   .c bind Stepback <Enter> ".c config -cursor hand2"
   .c bind Stepback <Leave> ".c config -cursor hand1"
   .c bind Coords <Enter> ".c config -cursor hand2"
   .c bind Coords <Leave> ".c config -cursor hand1"
   .c bind Whiteplayer <Enter> ".c config -cursor hand2"
   .c bind Whiteplayer <Leave> ".c config -cursor hand1"
   .c bind Blackplayer <Enter> ".c config -cursor hand2"
   .c bind Blackplayer <Leave> ".c config -cursor hand1"
   .c bind Prefs <1> "changeBack $c"
   .c bind Stepback <1> "stepBack"
   .c bind Logout <1> "logOut"
   .c bind Stepforward <1> "stepForward $sock"
   .c bind Reset <1> "refreshBoard $sock"
   .c bind Coords <1> "drawCoords"
}

proc initVars {} {
   global RX RY serverinfo commands getrankinfo playcount loggedin lastline
   global whiterank blackrank connected movenum capmoves gamenum variation
   global getlogin opponent whiteplayer blackplayer playing wcapt bcapt
   global dotick wtime btime passes scoring turn bstonelist wstonelist
   global drawcoords databuffer movelist sfwdlist bbyostones wbyostones
   global capmove topedge bottomedge sfwdlist2 backgrounds background
   set RX "1"
   set RY "1"
   set serverinfo ""
   set commands ""
   set getrankinfo 0
   set playcount 0
   set loggedin 0
   set lastline ""
   set whiterank ""
   set blackrank ""
   set connected "no"
   set movenum 0
   set capmoves ""
   set gamenum ""
   set variation "1"
   set getlogin 0
   set opponent "none"
   set whiteplayer ""
   set blackplayer ""
   set playing "not"
   set wcapt 0
   set bcapt 0
   set dotick 0
   set wtime 0
   set btime 0
   set passes 0
   set scoring 0
   set turn "black"
   set bstonelist ""
   set wstonelist ""
   set drawcoords 1
   set databuffer ""
   set movelist "none"
   set sfwdlist ""
   set sfwdlist2 ""
   set bbyostones "--"
   set wbyostones "--"
   for {set maxmoves 0} {$maxmoves < 450} {set maxmoves [expr $maxmoves+1]} {
      set capmove($maxmoves) ""
   }
   for {set edge 1} {$edge < 344} {set edge [expr $edge+19]} {
      lappend topedge $edge
   }
   for {set edge 19} {$edge < 362} {set edge [expr $edge+19]} {
      lappend bottomedge $edge
   }
}   
